// Definimos las variables globales
float y, y0;
float v;
float a;
float t, t0;
float A = 200;
float T = 4;
float phi = PI;
  
boolean update;
  
  
void setup()
{
 size(600, 600);
 frameRate(70);
 background(0);
 strokeWeight(2);
  
 y=height/2;
 t0=millis()/1000.;
 update = true;
}
  
void draw()
{
  
 if(update){
 // Calculamos las variables del movimiento
 t = (millis()/1000.)-t0;
 y = height/2+A*sin(2*PI*t/T + phi);
 v = A*cos(2*PI*t/T+phi);
 a = -A*sin(2*PI*t/T+phi);
  
 /////////////////////////////////////
 // Pintamos la bola
 /////////////////////////////////////
 background(0);
 fill(255); 
 stroke(0);
 ellipse(width/2, y, 10, 10);
  
 /////////////////////////////////////
 // Pintamos el vector velocidad
 /////////////////////////////////////
 stroke(100,100,255);
  
 // Con origen a la bola
 line(width/2+1, y, width/2+1, y+v);
 // Pintamos la cabeza de la flecha
 line(width/2, y+v, width/2-5, y+v-(v/abs(v))*5);
 line(width/2, y+v, width/2+5, y+v-(v/abs(v))*5);
  
 /////////////////////////////////////
 // Pintamos el vector aceleración
 /////////////////////////////////////
 stroke(120,6,23);
  
 // Con origen a la bola
 line(width/2-1, y, width/2-1, y+a);
 // Pintamos la cabeza de la flecha
 line(width/2, y+a, width/2-5, y+a-(a/abs(a))*5);
 line(width/2, y+a, width/2+5, y+a-(a/abs(a))*5);
 }
}
  
void mouseClicked() {
 update = !update;
 if(update)
 {
 t0=millis()/1000. -t;
 }
}
