PVector r, r0;
PVector v;
PVector a;
float R, T, w, R0, T0, nw, nR;
boolean pressed;
 
void setup()
{
  size(600, 600);
  frameRate(70);
  background (0);
  
  pressed = false;
   R0 = 200;
  T0 = 2;
  T=T0;
  w=2*PI/T0;
//  R = 200;
//  T = 2;
  
  r = new PVector(R,0);
  r0 = new PVector(width/2, width/2);
  
  v = new PVector(0, 2*PI*R/T);    //  Definimos la velocidad en función del radio y el período
  a = new PVector(4*PI*PI*R/(T*T), 0);  // Lo mismo para la aceleración normal
  
    fill(255);
  textSize(20);
  text("Clica para iniciar el movimento", 100, 50);
  textSize(15);
  text("Como más hacia la derecha cliquéis, más grande será el valor del periodo del movimento", 50, 80);
  
  textSize(30);
  text("T", 50, 125);
  text("T", 500, 125);
  stroke(255);
  line(80, 130, 80, 105);
  line(80, 130, 75, 125);
  line(80, 130, 85, 125);
  line(530, 105, 530, 130);
  line(530, 105, 525, 110);
  line(530, 105, 535, 110);
}
 
void draw()
{
  if (pressed == true)
  {
  
  // Cálculos
  /////////////////////////////////
  // Calculamos el instante de tiempo
  float t = millis()/1000.;
  
  //Calculamos el radio en función de la velocidad de giro
  
  R=(R0*T*T)/(T0*T0);   // Mantenemos constante la aceleración angular (4PI*PI*R/T) para ver el efecto que tiene
                        // el cambio de velocidad en el radio de giro.
  
  // Calculamos la posición de la bola
  r.x = r0.x + R*cos(2*PI*t/T);
  r.y = r0.y + R*sin(2*PI*t/T);
  
  // Calculamos el vector velocidad
  v.x = -R*sin(2*PI*t/T);
  v.y = R*cos(2*PI*t/T);
  
  // Calculamos la aceleración 
  a.x = -R*cos(2*PI*t/T);
  a.y = -R*sin(2*PI*t/T);

  // Dibujamos los resultados
  
  background(0);
  
  // Dibujamos la trayectoria circular
  fill(0);
  stroke(255);
  strokeWeight(1);
  ellipse(width/2, height/2, 2*R, 2*R);

  // Dibujamos la bola
  fill(255);
  ellipse(r.x, r.y, 15, 15);
  
  // Dibujamos el vector velocidad
  strokeWeight(4);
  stroke(100, 100, 255);
  line(r.x, r.y, r.x+v.x, r.y+v.y);
  pinta_el_cap_de_fletxa(r.x, r.y, r.x+v.x, r.y+v.y);
  
  // Dibujamos el vector aceleración
  stroke(120,6,23);
  line(r.x, r.y, r.x+a.x, r.y+a.y);
  pinta_el_cap_de_fletxa(r.x, r.y, r.x+a.x, r.y+a.y);
    
  //Volvemos a añadir aquí el texto porqué la pantalla se va borrando
  fill(255);
  textSize(20);
  text("Clica para iniciar el movimento", 100, 50);
  textSize(15);
  text("Como más cap a la derecha cliquéis, más grande será el valor del periodo del movimento", 50, 80);
  
  textSize(30);
  text("T", 50, 125);
  text("T", 500, 125);
  stroke(255);
  line(80, 130, 80, 105);
  line(80, 130, 75, 125);
  line(80, 130, 85, 125);
  line(530, 105, 530, 130);
  line(530, 105, 525, 110);
  line(530, 105, 535, 110);
  
    stroke(255);
    fill(125);
    rect(50, 500, 325, 75);

    w=2*PI/T; //Calculamos la velocidad angular e imprimimos los datos
  
   String nw = nf(w, 1, 2);
   String nR = nf(R, 2, 1);
      
    String str1 = "Velocidad angular (rad/s): " + nw;
    String str2 = "Radio de la trayectoria (m): "+nR;
    
    fill(0);
    textSize(20);
    text(str1, 80, 525);
    text(str2, 80, 550);
  }
}
 
void pinta_el_cap_de_fletxa(int x1, int y1, int x2, int y2)
{
  float a = atan2(x1-x2, y2-y1);  
  pushMatrix();
  translate(x2, y2);
  rotate(a);
  line(0, 0, -10, -10);
  line(0, 0, 10, -10);
  popMatrix();    
}
 void mousePressed()
{
  pressed = true;
  t0 = millis()/1000.;
  T=mouseX/250;
//  pos.x = 100;
//  pos.y = 300;
}
