//Definimos las variables.
 PVector  pos, pos0;
 boolean pressed;
 float t0, k, m, Epe, Ec, v, x;
 
 void setup()
 {
   size(600, 600);
   background(0);
   strokeWeight(2);
  
   // Inicializamos las variables.
   pressed = false;
  
   pos = new PVector(100, 300);
   pos0 = new PVector(100, 300);
   m = 2;
   x=1.5;
   k=2;
 }
 
 void draw()
 {
   background(0);
   fill(255);
   rect(20, 275, 50, 50, 10);
   ellipse(pos.x, pos.y, 75, 75);
   rect(560, 175, 25, 250);
  
   fill(255);
   textSize(18);
   text("Clica para escoger una constante elástica y disparar el muelle", 20, 50);
   textSize(15);
   text("Cuanto más hacia la derecha cliquéis, más grande será el valor de k", 50, 80);
  
   textSize(30);
   text("k", 50, 125);
   text("k", 500, 125);
   stroke(255);
   line(80, 130, 80, 105);
   line(80, 130, 75, 125);
   line(80, 130, 85, 125);
   line(530, 105, 530, 130);
   line(530, 105, 525, 110);
   line(530, 105, 535, 110);

   if (pressed == true)
   {
     // Calculamos el tiempo que ha pasado desde que ha empezado el programa.
     float t = millis()/1000. - t0;
  
    // Calculamos la energía potencial del muelle:
   
         Epe =0.5*k*x*x;
        
   //Calculamos la velocidad que tendrá la bola suponiendo que toda la energía elástica
   // se convierte en energía cinética.
  
         v=sqrt((k*x*x)/m); // Hemos igualado la energía cinética a la energía elástica y hemos
                            // aislado la velocidad.
        
   // Calculamos la posición  de la bola utilizando las ecuaciones de cinemática.
  
         pos.x= pos0.x + (v*t)*50; 
  
   //Calculamos la energía cinética al llegar a la pared.
  
         Ec=0.5*m*v*v;
   
     fill(255);
     stroke(255);
     ellipse(pos.x, pos.y, 75,75);
    
     
     if(pos.x>(width-50))
   {
      pressed = false;

     }
   }
  
   // Imprimimos los datos limitando los decimales.
    
     fill(0,255,0);
     String nEpe = nf(Epe, 2, 2);
     String str0="Epe: " + nEpe;
     textSize (20);
     text (str0, 50, 225);
    
     fill(0,255,0);
     String nEc = nf(Ec, 2, 2);
     String str1="Ec: " + nEc;
     textSize (20);
     text (str1, 450, 225);
    
     stroke(255);
     fill(125);
     rect(50, 470, 300, 75);

     String nk = nf(k, 2, 2);
     String nv = nf(v, 1, 2);
      
     String str2 = "Constante del muelle: " + nk;
     String str3 = "Velociat de la bola: "+nv;
    
     fill(0);
     textSize(15);
     text(str2, 80, 500);
     text(str3, 80, 525);
    
 }
 
 void mousePressed()
 {
   pressed = true;
   t0 = millis()/1000.;
   k=mouseX/50;
   pos.x = 100;
   pos.y = 300;
  
 }
