// Definimos las variables.
 PVector  pos, pos0;
 boolean pressed;
 float t0, v0, k, m, n, Epe, Ec, v, x, uno, Wf, g, a;
 
 void setup()
 {
   size(600, 600);
   background(0);
   strokeWeight(2);
  
   // Inicializamos las variables.
   pressed = false;
  
   pos = new PVector(100, 300);
   pos0 = new PVector(100, 300);
   m = 15;
   x=50;
   k=5;
   g=10;
   uno=0.4;
   a=0;
 }
 
 void draw()
 {
   background(0);
   fill(255);
   stroke(255);
   rect(20, 275, 50, 50, 10);
   ellipse(pos.x, pos.y, 70, 70);
  
   fill(100);
   stroke(100);
   rect(560, 200, 25, 150);
   rect(10, 335, 550, 15);
  
   fill(255);
   textSize(20);
   text("Clica para disparar el muelle", 100, 50);
   textSize(15);
   text("Cuanto más hacia la derecha cliquéis, más grande será el valor de k", 50, 80);
  
   textSize(30);
   text("k", 50, 125);
   text("k", 500, 125);
   stroke(255);
   line(80, 130, 80, 105);
   line(80, 130, 75, 125);
   line(80, 130, 85, 125);
   line(530, 105, 530, 130);
   line(530, 105, 525, 110);
   line(530, 105, 535, 110);
  
       // Calculamos la energía generada por el muelle.
   
         Epe =0.5*k*x*x;
        
   // Calculamos la velocidad inicial que tendrá la bola suponiendo que la energía elástica
   // inicial se convierte en energía cinética.
  
    v0=sqrt((k*x*x)/m);
   
     if (pressed == true)
   {
     // Calculamos el tiempo que ha pasado desde que ha empezado el programa.
     float t = millis()/1000. - t0;
 
         Wf=uno*m*g*(pos.x-pos0.x);  // Calculamos el trabajo de la fuerza de fricción.
         
         Ec=Epe-Wf;  //Calculamos la energía cinética.
       
         v=sqrt((2*Ec)/m)/10;   //Calculamos la velocidad.
       
  // Calculamos la posición utilizando las ecuaciones de cinemática.
     a=((v-v0)/t);
     pos.x= pos0.x + v0*t+0.5*a*t*t;
          
     fill(255);
     stroke(255);
     ellipse(pos.x, pos.y, 75,75);
     
     if(pos.x>(width-50)) // Paramos la bola al llegar a la pared.
   {
      pressed = false;
     }
     if ((Ec<=0) || (Wf>=Epe)) // Paramos la bola cuando se acabe la energía inicial
                               // y dejamos la bola parada en aquel punto.
     {
       pressed = false;
     
       pos.x = ((Epe-Ec)/(uno*m*g))+pos0.x;
       v=0;
       Ec=0;
       a=0;
     }
      
   }
  
    // Imprimimos los datos limitando los decimales.
    
     fill(0,255,0);
     String nEpe = nf(Epe, 5, 1);
     String str0="Epe: " + nEpe;
     textSize (20);
     text (str0, 50, 175);
    
     fill(0,255,0);
     String nEc = nf(Ec, 5, 1);
     String str1="Ec: " + nEc;
     textSize (20);
     text (str1, 450, 175);
    
     stroke(255);
     fill(125);
     rect(50, 425, 300, 150);

     String nk = nf(k, 2, 2);
     String nv = nf(v, 1, 2);
     String nWf = nf(Wf, 5, 1);
      
     String str2 = "Constante del muelle: " + nk;
     String str3 = "Velociat de la bola (m/s^2): "+nv;
     String str4 = "Epe (J): "+nEpe;
     String str5 = "Ec (J) : "+nEc;
     String str6 = "Wfr (J) : " +nWf;
 
    
     fill(0);
     textSize(15);
     text(str2, 80, 450);
     text(str3, 80, 475);
     text(str4, 80, 500);
     text(str5, 80, 525);
     text(str6, 80, 550);
 }
 
 void mousePressed()
 {
   pressed = true;
   t0 = millis()/1000.;
   k=mouseX/20;
   pos.x = 100;
   pos.y = 300;
 }
