//Definimos primero las variables que utilizaremos.

 PVector pos1, pos2;
 boolean pressed;
 float t0, a, m1, m2, g;
 float b, c, d, e;
 
 void setup()
 {
   size(600, 600);
   background(0);
   strokeWeight(2);
  
   // Inicializamos las variables.
   pressed = false;
   pos1 = new PVector(250, 350);
   pos2 = new PVector(350,350);
   b=300;
   c=400;
   d=300;
   e=400;

   m1 = 5;
   m2 = 5;
   g = 10;
 
 }
 
 void draw()
 {
   background(0);
    // Pintamos los cuerpos y dibujamos el sistema de cuerdas
    // y polea.
  
     fill(0,255,0);
     stroke(0,255,0);
    
     rect(pos1.x-30, pos1.y-20, 60, 40, 7);
     fill(0);
     textSize(15);
     text("m1", pos1.x-10, pos1.y+5);
    
     fill(0,255,0);
     stroke(0,255,0);
     rect(pos2.x-30, pos2.y-20, 60, 40, 7);
     fill(0);
     textSize(15);
     text("m2", pos2.x-10, pos2.y+5);
    
     fill(0,255,255);
     stroke(0,255,255);
     ellipse(300, 100, 100, 100);
     line(pos1.x, pos1.y-20, pos1.x, 100);
     line(pos2.x, pos2.y-20, pos2.x, 100);
    
     // Dibujamos las fuerzas
    
     stroke(250,100,50);
     line(pos1.x, pos1.y-20, pos1.x, b);
     line(pos1.x-10, b+10, pos1.x, b);
     line(pos1.x+10, b+10, pos1.x, b);
     fill(250,100,50);
     text("T1", pos1.x-30, b);
    
     stroke(250,100,50);
     line(pos2.x, pos2.y-20, pos2.x, d);
     line(pos2.x-10, d+10, pos2.x, d);
     line(pos2.x+10, d+10, pos2.x, d);
     fill(250,100,50);
     text("T2", pos2.x-30, d);
    
   
     stroke(50,100,250);
     line(pos1.x, pos1.y+20, pos1.x, c);
     line(pos1.x-10, c-10, pos1.x, c);
     line(pos1.x+10, c-10, pos1.x, c);
     fill(50,100,250);
     text("P1", pos1.x-30, c);
    
     stroke(50,100,250);
     line(pos2.x, pos2.y+20, pos2.x, e);
     line(pos2.x-10, e-10, pos2.x, e);
     line(pos2.x+10, e-10, pos2.x, e);
     fill(50,100,250);
     text("P2", pos2.x-30, e);
          
   if (pressed == true)
   {
     // Calculamos el tiempo que ha pasado desde que ha empezado el programa.
     float t = millis()/1000. - t0;
    
     // Calculamos la aceleración en función de las masas de los cuerpos
     // y los desplazamientos relativos
    
     a = (((m1-m2)*g)/(m1+m2))/5;  //Aquí podemos escoger qué sentido consideramos
                                   //como aceleración positiva. Hemos cogido el
                                   //peso del cuerpo 1 como dirección positiva, por lo tanto
                                   //tendremos aceleración positiva cuando el cuerpo 1 se
                                   //mueva hacia abajo.
    
     // Utilizamos las ecuaciones de cinemática del MRUA para calcular como varía la 
     // posición de los dos cuerpos en función de su aceleración.
    
     pos1.y = pos1.y + 0.5*a*t*t; 
     pos2.y = pos2.y - 0.5*a*t*t;
    
     // Variamos la medida de los vectores correspondientes a las fuerzas de tensión
     // y peso en función de la variación de masa del cuerpo 1
    
     if (m1<5) {
      
       b=pos1.y-100;
       c=pos1.y+60;
       d=pos2.y-60;
       e=pos2.y+100;
     }
       else if (m1>5) {
        
       b=pos1.y-60;
       c=pos1.y+100;
       d=pos2.y-100;
       e=pos2.y+60;
     }
    
     else {
     b=pos1.y-70;
     c=pos1.y+70;
     d=pos2.y-70;
     e=pos2.y+70;
     }
   
      // Imprimimos los datos.
     stroke(255);
     fill(125);
     rect(25, 300, 150, 100);
  
     String ra = nf(a,1,2); // Limitamos a 2 el número de decimales de la aceleración.
     String str1 = "Masa m1 : " + m1;
     String str2 = "Masa m2: " + m2;
     String str3 = "Aceleración: " + ra;
    
     fill(0);
     textSize(15);
     text(str1, 35, 325);
     text(str2, 35, 350);
     text(str3, 35, 375);
    
 // Añadimos la condición que pare el programa si algún cuerpo sale de la pantalla.   

     if(pos1.y>height)
     {
       pressed = false;
     }
        if(pos2.y>height)
     {
       pressed = false;
     }
   }
   else
   {
    fill(255);
     textSize(15);
     text("Clica para variar ", 50, 70);
     text("la masa de m1", 50, 100);
   pos1.x = 250;
   pos1.y = 350;
   pos2.x = 350;
   pos2.y = 350;
   b=pos1.y-70;
   c=pos1.y+70;
   d=pos2.y-70;
   e=pos2.y+70;
   }
 }
 
 void mousePressed()
 {
   m1 = mouseY/50;
   pressed = true;
   t0 = millis()/1000.;
 }
