PVector centro, punto1, punto2, punto3, objeto;
float radio, altura, theta;
float dist;
float angleinc1, angleinc2, angleinc3;

void setup() {
 size(1010, 500);
 dist=sqrt(width*width+height*height);
 // Inicializamos variables
 objeto = null;
 radio = 500;
 centro = new PVector(width-radio-10, height/2);
 altura = 50;
 theta = asin(altura/radio);
 punto1 = new PVector(centro.x + radio, centro.y);
 punto2 = new PVector(centro.x + radio*cos(theta), centro.y + altura);
 punto3 = new PVector(centro.x + radio*cos(theta), centro.y - altura);
}

void draw() {
 background(255);
  
 // Pinta el espejo
 ////////////////////////
 //Pintamos el fondo azul
fill(124, 204, 196);
 noStroke();
 rect(width-500, 0, 510, 500);
 // Pintamos el espejo, que representamos con un círculo
fill(255);
 stroke(0);
 ellipse(centro.x, centro.y, 2*radio, 2*radio); 
 noStroke();
 rect(0,0,centro.x, height);
 // Pinta el eje del espejo
 stroke(0);
 line(0, height/2, width, height/2);
 // Pintamos el centro del espejo
fill(0);
 line(centro.x, centro.y -5, centro.x, centro.y+5);
 text("C", centro.x-3, centro.y-20);
 // Pintamos el punto focal
 line(centro.x+radio/2, centro.y -5, centro.x+radio/2, centro.y+5);
 text("F", (centro.x+radio/2)+3, centro.y-20);
fill(255);
  
 if(objeto != null)
 {
 stroke(255,125,125);
  
 line(objeto.x, objeto.y, punto1.x, punto1.y);
 line(objeto.x, objeto.y, punto2.x, punto2.y);
 line(objeto.x, objeto.y, punto3.x, punto3.y);
  
 pushMatrix();
 translate(punto1.x, punto1.y);
 rotate(PI-angleinc1);
 line(0,0,dist,0);
 popMatrix();
  
 pushMatrix();
 translate(punto2.x, punto2.y);
 rotate(PI+theta-angleinc2);
 line(0,0,dist,0);
 popMatrix();
  
 pushMatrix();
 translate(punto3.x, punto3.y);
 rotate(PI-theta-angleinc3);
 line(0,0,dist,0);
 popMatrix();
 }
}

void mouseClicked(){
 objeto = new PVector(mouseX, mouseY);
  
 //punto1: sobre el eje 
 angleinc1 = atan((punto1.y-objeto.y)/(punto1.x-objeto.x));
 angleinc2 = atan((punto2.y-objeto.y)/(punto2.x-objeto.x))-theta;
 angleinc3 = atan((punto3.y-objeto.y)/(punto3.x-objeto.x))+theta;
}
