// Definimos las características generales de la ventana principal del 
// programa
void setup() 
{
 size(600, 600); // Creamos la ventana
}

// Bucle principal del programa
void draw() 
{
 background(0); // Borramos la pantalla
  
 // Dibujamos los nuevos ejes
 stroke(255); // Definimos el color de las lineas que dibujaremos 
 // (255 es el valor de blanco)
 line(0, height/2, width, height/2); // Dibujamos el eje x
 line(width/2, 0, width/2, height); // Dibujamos el eje y
  
 // Escribimos el texto con la posición del cursor
 textSize(20); // Definimos la medida del texto
 // Definimos las variables de la nueva posición del ratón
 int new_mouseX, new_mouseY;
 new_mouseX = mouseX - width/2;
 new_mouseY = mouseY - height/2;
 text("Coordenadas Processing: (" +new_mouseX+", "+new_mouseY+")", 
 10, 50); 

 // Definimos las variables que utilizaremos por las coordenadas
 // cartesianas como integer (enteras)
 int x, y; 
 // Calculamos las coordenadas cartesianas
 x = new_mouseX; // La coordenada x es igual que en Processing
 y = -new_mouseY; // A la coordenada y le tenemos que cambiar el signo
 // Escribim el texto con la posición del cursor en cartesianas
 text("Coordenadas cartesianas: (" +x+", "+y+")", 10, 90);
  
 // Definimos las variables que utilizaremos por las coordenadas polares
 float r, theta; 
 // Calculamos las coordenadas polares
 r = sqrt(x*x+y*y); // r es la distancia desde el origen al punto dónde 
 // está el ratón
 theta = atan2(float(y),float(x)) *180/PI; // theta es el arctan(y/x) 
 // Escribim el texto con la posición del cursor en polares
 text("Coordenadas polares: (" +int(r)+", "+theta+")", 10, 130);
}
