PVector r, r0;
boolean pressed;
float t0;
float v0, a;
  
void setup()
{
 size(600, 600);
 background(0);
 strokeWeight(2);
  
 // Initialize variables
 pressed = false;
 r0 = new PVector(0,0);
 r = new PVector(0,0);
 v0 = -500;
 a = 1000;
}
  
void draw()
{
 background(0);
 if (pressed == true)
 {
 // Calculamos el tiempo que ha pasado desde que ha empezado el programa
 float t = millis()/1000. - t0; 
 r.y = r0.y + v0 * t + 0.5*a*t*t;
 float vy = v0 + a*t;
fill(255);
 if(r.y>height)
 {
 pressed = false;
 }
  
 // Pintamos la bola
fill(255);
 stroke(255);
 ellipse(r0.x, r.y, 10,10);
  
 // Pintamos el vector velocidad
 noFill();
 stroke(100, 100, 255);
 line(r0.x-10, r.y, r0.x-10, r.y + vy*t);
 // Pintamos la cabeza de la flecha
 line(r0.x-10, r.y + vy*t, r0.x-15, r.y + vy*t - (vy/abs(vy))*5);
 line(r0.x-10, r.y + vy*t, r0.x-5, r.y + vy*t - (vy/abs(vy))*5);
  
 // Pintamos el vector aceleración
 stroke(120,6,23);
 line(r0.x-20, r.y, r0.x-20, r.y + a/10);
 line(r0.x-20, r.y + a/10, r0.x-25, r.y + a/10-5);
 line(r0.x-20, r.y + a/10, r0.x-15, r.y + a/10-5);
 }
 else
 {
fill(random(0,255), random(0, 255), random(0,255));
 textSize(40);
 text("¡clica!", 250, 300);
 }
}
  
void mousePressed()
{
 r0.x = mouseX;
 r0.y = mouseY;
 pressed = true;
 t0 = millis()/1000.;
}
