PVector pV01, pV02, pV03, pV04;
PVector pV1, pV2, pV3, pV4;
  
PImage fondo;
  
float t, t0;
float R = 100;
float T = 4;
  
float theta01=0;
float theta02=PI/2;
float theta03=PI;
float theta04=3*PI/2;
  
boolean update;
  
void setup()
{
 size(1100, 300);
 frameRate(70);
 background(0);
  
 t0=millis()/1000.;
  
 update = true;
  
 pV01 = new PVector(150, 150);
 pV02 = new PVector(400, 150);
 pV03 = new PVector(650, 150);
 pV04 = new PVector(950, 150);
  
 pV1 = new PVector(0, 0);
 pV2 = new PVector(0, 0);
 pV3 = new PVector(0, 0);
 pV4 = new PVector(0, 0);
  
 stroke(255);
 fill(0);
  
 ellipse(pV01.x, pV01.y, 2*R, 2*R);
 ellipse(pV02.x, pV02.y, 2*R, 2*R);
 ellipse(pV03.x, pV03.y, 2*R, 2*R);
 ellipse(pV04.x, pV04.y, 2*R, 2*R);
  
 fondo = get();
  
 fill(255);
}
  
void draw()
{
 if(update) 
 {
 set(0,0, fondo);
  
 t = (millis()/1000.)-t0;
  
 pV1.x = pV01.x + R * cos( 2*PI*t/T + theta01);
 pV1.y = pV01.y + R * sin( 2*PI*t/T + theta01);
 ellipse(pV1.x, pV1.y, 10, 10);
  
 pV2.x = pV02.x + R * cos( 2*PI*t/T + theta02);
 pV2.y = pV02.y + R * sin( 2*PI*t/T + theta02);
 ellipse(pV2.x, pV2.y, 10, 10);
  
 pV3.x = pV03.x + R * cos( 2*PI*t/T + theta03);
 pV3.y = pV03.y + R * sin( 2*PI*t/T + theta03);
 ellipse(pV3.x, pV3.y, 10, 10);
  
 pV4.x = pV04.x + R * cos( 2*PI*t/T + theta04);
 pV4.y = pV04.y + R * sin( 2*PI*t/T + theta04);
 ellipse(pV4.x, pV4.y, 10, 10);
 };
}
  
void mouseClicked()
{
 update = !update;
 if(update)
 {
 t0 = (millis()/1000.) - t;
 }
}
