// Definimos las variables globales
int y; // Número de iteraciones de la función draw()
float recorrido; 

// Definimos las variables de ejecución 
void setup(){
 // Definimos la ventana del programa, la frecuencia de actualización y 
 // el color de fondo.
 size(600,600);
 frameRate(70);
 background(0);

 // Inicializamos las variables globales 
 y=0;
 recorrido=0;
}

void draw()
{
 if (y>0)
 {
 stroke(255);
 line(pmouseX, pmouseY, mouseX, mouseY);
 recorrido = recorrido + sqrt((mouseX-pmouseX)*(mouseX-pmouseX)+
 (mouseY-pmouseY)*(mouseY-pmouseY));
 y++;
 }
 // Escribimos los resultados:
 // Dibujamos el background de la caja de texto.
 fill(100, 100, 100);
 noStroke();
 rect(15, 480, 300, 60);

 // Escribimos la información del recorrido
 String str = "Recorrido (pixels): " + recorrido ;
 fill(255, 255, 255);
 text( str , 20, 500); 
}

void mouseClicked()
{
 // Esta función se llama cuando se clica el ratón 
 background(0); // Borramos la pantalla
 y=1; // Inicializamos el contador y a 1
 recorrido = 0;
}
