// Definimos las variables.
 float t, t0, h, h0, h1, v, v0, nv, Ep, Ec, m, g, TE, nEp, nEc;
 PVector a, b, c;
 boolean pressed,up;

 //Inicializamos las variables.
 void setup()
 {
   size(600, 600);
   frameRate(70);
   pressed = false;
   m=2;
   g=10;
   a= new PVector (290, 360);
   b= new PVector (300, 340);
   c= new PVector (310, 360);
   v=0;
   v0=0;
 }
 
 void draw()
 {
   background (0); 
   fill(255);
   textSize(20);
   text("Clica para iniciar.", 60, 500);
   text("¡Cuanto más arriba, más rápido saldrá el cohete!", 60, 530);
   
  
   strokeWeight(4);
   stroke (255);
   rect (a.x, a.y, 20, 40); // Dibujamos el cohete.
   triangle (a.x, a.y, b.x, b.y, c.x, c.y);
  
   // Añadimos el texto con los valores redondeados de la energía cinética y potencial.
   fill (255);
   textSize(20);
   String nEp = nf(Ep, 4, 1);
   String nEc = nf(Ec, 4, 1);
   String str1 = "Ep = " + nEp + " J";
   String str2 = "Ec = " + nEc + " J";
   text(str1, 70, 130);
   text(str2, 420, 130);
    
  if (pressed == true)
  {
    // Calculamos el instante de tiempo.
   float t = (millis()/1000. - t0);
     
    // Calculamos la energía cinética y potencial. Tenemos que hacer por separado la parte que sube y la que baja.
   
    if (up==true)
    {
      v=v0+0.1;
      Ec=0.5*m*v*v; // Energía cinética.
      h1=h0+(Ec-0.5*m*v0*v0)/g;  // Energía potencial.
     
     // Calculamos posición.
     a.y = h1;
     b.y = h1-20;
     c.y = h1;
    }
      else // Repetimos los pasos anteriores en el supuesto de que el cohete baje.
     {
      v=v0-0.1;
      Ec=0.5*m*v*v;
      h1=h0+(Ec-0.5*m*v0*v0)/g;
     
     a.y = h1;
     b.y = h1-20;
     c.y = h1;
     
    }

    Ec = 0.5*m*v*v;
    Ep=TE-Ec;
    h0=h1;
    v0=v;
    if (v0==0)
    {
      up = false;
    }
 
     //La altura de los rectángulos será siempre 100. Calculamos el porcentaje que representa cada altura.
     // Por lo tanto hacemos el cociente de Ec/TE y Ep/TE y multiplicamos por 100.

     fill (125);
     rect(90, 400-(Ep/TE*200), 40, (Ep/TE*200));
     rect(450, 400-(Ec/TE*200), 40, (Ec/TE*200));
   }
    if (Ep<0)
   {
     Ep=0;
     pressed = false;
     }

 }
 void mousePressed()
 {
   v0 = -(600-mouseY)/10;
   pressed = true;
   up=true;
   t0 = millis()/1000.;
   h0=360;
   a.x = 290;
   a.y= h0;
   b.x=300;
   b.y=h0-20;
   c.x=310;
   c.y=h0;
   h1=h0;
   v=0;
   TE=0.5*m*v0*v0;
 }
