// Definimos las variables.
 PVector pos1, pos01;
 boolean pressed;
 float t0;
 float a, Fr, v0, uno, uf, g, v, nv;
 
 void setup()
 {
   size(600, 600);
   background(0);
   strokeWeight(2);
  
   // Inicializamos las variables.
   pressed = false;
   pos1 = new PVector(25, 300);
   pos01 = new PVector(25, 300);

   v0 = 100;
   a = 0;
   uf = 0.35;
   g = 10;
 
 }
 
 void draw()
 {
   background(0);
   fill(255);
   textSize(20);
   text("Clica para aplicar una fricción", 50, 100);
   textSize(25);
   text("μ", 50, 150);
   text("μ", 500, 150);
   stroke(255);
   line(80, 155, 80, 135);
   line(80, 155, 75, 150);
   line(80, 155, 85, 150);
   line(530, 155, 530, 135);
   line(530, 135, 525, 140);
   line(530, 135, 535, 140);

  
    // Pintamos la bola.
   fill(0,255,0);
   stroke(0,255,0);
   ellipse(pos1.x, pos1.y, 50, 50);
  
   fill(100);
   stroke(100);
   rect(1,325,599,20);
   
      // Calculamos el tiempo que ha pasado desde que ha empezado el programa.
   float t = millis()/1000. - t0;
     
   if (pressed == true)
   {
    
     //Calculamos la aceleración a partir de la fuerza de fricción.
    
     uf=uno/100;  // Reducimos el valor para apreciar mejor el efecto en la animación
     a = uf*g;   // Calculamos la aceleración a partir de la fuerza de fricción:
                 // F=un=umg --> F=ma --> Igualando tenemos: ma=umg --> a=ug
                 // Fijaos que la aceleración es independiente de la masa del cuerpo.
    
    // Calculamos la variación de posición a partir de las leyes de cinemática de un MRUA.
    
     pos1.x = pos01.x + v0*t -0.5*(a/2)*t*t;        
     v = v0 - (a/2)*t;
    
        if (v<=0.05) // Condición porque se pare completamente.
          {
            pressed = false;
          }
        if (pos1.x>width) // Condición porque se pare al salir de la pantalla.
        {
          pressed = false;
          pos1.x = 25;
          pos1.y = 300;
        }
   }
            // Imprimimos los datos.
     stroke(255);
     fill(125);
     rect(20, 400, 250, 70);
    
     // Limitamos los valores a un decimal.
     String nv = nf(v, 2, 1);
     String na = nf(a, 1, 1);
    
     String str1 = "Velocidad: " + nv;
     String str2 = "Aceleración: -" + na;
     String str3 = "Coeficiente de rozamiento: " + uf;
    
     fill(0);
     textSize(15);
     text(str1, 30, 420);
     text(str2, 30, 440);
     text(str3, 30, 460);    
 
 }
 
 void mousePressed()
 {
 
   pressed = true;
   t0 = millis()/1000.;
   pos1.x=25;
   pos1.y=300;
   pos01.x=25;
   pos01.y=300;
   uno=mouseX;
 }
