// Definimos las variables.
 PVector pos1, pos2, pos01, pos02, posCM, pos0CM;
 boolean pressed;
 float t01, t02, t1, t2, t0, t;
 float v1, v2, v, m1, m2;

 void setup()
 {
   size(600, 600);
   background(0);
   strokeWeight(2);
  
   // Inicializamos las variables.
   pressed = false;
   pos1 = new PVector(100, 300);
   pos2 = new PVector(500, 300);
   posCM = new PVector (300, 300);
   pos0CM = new PVector (300, 300);
   pos01 = new PVector (100, 300);
   pos02 = new PVector (500, 300);
   v1 = 150;
   v2 = 70;
   m1 = 2;
   m2 = 5;
   v=0;

  }
 
 void draw()
 {
   background(0);
    // Pintamos las bolas.
     fill(0,255,0);
     stroke(0,255,0);
     ellipse(pos1.x, pos1.y, 20, 20);
   
     fill(255,255,0);
     stroke(255,255,0);
     ellipse(pos2.x, pos2.y, 50, 50);
    
     // Calculamos la posición del CM.
   
     posCM.x = (m1*pos1.x+m2*pos2.x)/(m1+m2);
     posCM.y = (m1*pos1.y+m2*pos2.y)/(m1+m2);
    
     fill(255);
     stroke(255);
     ellipse(posCM.x, posCM.y, 10, 10);
    
     textSize(25);
     text("CM", posCM.x-50, posCM.y);
     textSize(15);
     text("Vcm", posCM.x+35, posCM.y);
   
   
   if (pressed == true)
   {
     // Calculamos el tiempo que ha pasado desde que ha empezado el programa.

    t1 = millis()/1000. - t01;
    t2 = millis()/1000. - t02;
    t= millis ()/1000.-t0;
  
     // Describim el movimiento del cuerpo 1. Tenemos que tener en cuenta que al llegar a los límites
     // de la pantalla, la velocidad tiene que cambiar de signo.
    
    if ((pos1.y>0) & (pos1.y<600))
    {
      pos1.y = pos01.y - v1*t1;
       
    }
     if (pos1.y <= 0)
    {
      v1=-v1;
      pos1.y=1;
      pos01.y=1;
      t01 = millis()/1000.;
      t0 = millis()/1000.;
    
    }
     if (pos1.y>=600)
    {
      v1= - v1;
      pos1.y=599;
      pos01.y=599;
      t01 = millis()/1000.;
      t0 = millis()/1000.;

    }
   
       // Describimos el movimiento del cuerpo 2 con las mismas condiciones que en el cuerpo 1.
   
     if (pos2.y>0 & (pos2.y<600))
    {
      pos2.y = pos02.y - v2*t2;
     
    }
     if (pos2.y <= 0)
    {
      v2=-v2;
      pos2.y = 1;
      pos02.y=1;
      t02 = millis()/1000.;
      t0 = millis()/1000.;
    }
    if (pos2.y>=600)
    {
      v2= - v2;
      pos2.y=599;
      pos02.y=599;
      t02 = millis()/1000.;
      t0 = millis()/1000.;
    }
   
      // Calculamos la velocidad del CM en función de las velocidades relativas de los otros dos cuerpos
      // y representamos el vector velocidad. Tenemos que contemplar todos los casos posibles de velocidades relativas.
     
    if ((v1>=0)&(v2>=0))
    {
     v= (m1*v1+m2*v2)/(m1+m2);

     stroke(250,100,50);
     strokeWeight(4);
     line(posCM.x+25, posCM.y, posCM.x+25, posCM.y-v*1.5);  // Hemos añadido un factor 1.5 a la velocidad para ver
                                                             // mejor el efecto.
     line(posCM.x+25, posCM.y-v*1.5, posCM.x+20, posCM.y-v*1.5+5);
     line(posCM.x+25, posCM.y-v*1.5, posCM.x+30, posCM.y-v*1.5+5);
     
    }
   
       if ((v1<0)&(v2>=0))
    {
     v= (m1*v1+m2*v2)/(m1+m2);
     t0 = millis()/1000.;
     stroke(250,100,50);
     strokeWeight(4);
     line(posCM.x+25, posCM.y, posCM.x+25, posCM.y-v*1.5);
     line(posCM.x+25, posCM.y-v*1.5, posCM.x+20, posCM.y-v*1.5+5);
     line(posCM.x+25, posCM.y-v*1.5, posCM.x+30, posCM.y-v*1.5+5);
    }
       if ((v1<=0)&(v2<0))
    {
     v= (m1*v1+m2*v2)/(m1+m2);
     t0 = millis()/1000.;
     stroke(250,100,50);
     strokeWeight(4);
     line(posCM.x+25, posCM.y, posCM.x+25, posCM.y-v*1.5);
     line(posCM.x+25, posCM.y-v*1.5, posCM.x+20, posCM.y-v*1.5-5);
     line(posCM.x+25, posCM.y-v*1.5, posCM.x+30, posCM.y-v*1.5-5);
    }
   
      if ((v1>=0)&(v2<0))
    {
     v= (m1*v1+m2*v2)/(m1+m2);
     t0 = millis()/1000.;
     stroke(250,100,50);
     strokeWeight(4);
     line(posCM.x+25, posCM.y, posCM.x+25, posCM.y-v*1.5);
     line(posCM.x+25, posCM.y-v*1.5, posCM.x+20, posCM.y-v*1.5-5);
     line(posCM.x+25, posCM.y-v*1.5, posCM.x+30, posCM.y-v*1.5-5);
    }
  
   }
   else
   {
     fill(255);
     textSize(30);
     text("Clica para iniciar el movimiento", 50, 100);
   pos1.x = 100;
   pos1.y = 300;
   pos2.x = 500;
   pos2.y = 300;
   }
 }

 void mousePressed()
 {
   pressed = true;
   t01 = millis()/1000.;
   t02 = millis()/1000.;
   t0 = millis()/1000.;
   pos1.y = 300;
   pos01.y = 300;
   pos2.y = 300;
   pos02.y = 300;
 }
